// $Id: binsrch2.e 1.2 1997/06/26 22:44:16 jbk Exp $
//
//
// Author: Alan Thompson
// 410 Church road  -  Unit 33
// Ojai, Ca.  93023-3152
// Alan4NTL@concentric.net
//
//

do_binary_search (elem, my_size, sizer)
char *elem;
int my_size;
int sizer;
{
	char elem_2[80];
	int try;
	int compare;
	sizer = (sizer >> 1);
	try = sizer;
	while (sizer) {
		sizer = (sizer >> 1);
		if (try > my_size) {
			try = (try - sizer);
		} else {
			point = try;
			(nl_reverse() ? point++ : 0);    // to_begin_line();
			mark = point;
			(nl_forward() ? point-- : 0);    // to_end_line();
			grab(mark, point, elem_2);
			if (compare = strfcmp (elem, elem_2))
			{
				if (compare > 0) {
					try = (try + sizer);
				} else {
					try = (try - sizer);
				}
			} else {
				return 1;
			}
		}
	}
	return 0;
}

//
// A binary search is at its most efficient when there are 2**N-1
// members to be searched.  (That's two to the Nth minus one.)  There
// are three reasons for this.
//
// 1.  There is always a point which is exactly half way between the
// beginning and the end.  You never have to "round up" or
// "truncate". 
//
// 2.  The calculation of where the next "try" should be is trivial
// and always independent of the starting and ending point of the
// area not yet searcht.
//
// and
//
// 3.  The number of iterations is predetermined rather than
// calculated.  (The number of iterations (of any style binary
// search) is always the same as the number of bits (both zero and
// one) which it takes to express the total number of items to
// search.  Example: If you have ten items it will take four
// iterations.  Ten = 1010 binary.  Four bits.  Try it for any
// number.)
//
// It is almost never that the number of members to be searcht is
// equal to 2**N-1.  What we do is calculate the next 2**N-1 number
// which is larger than the size of the buffer.  If the search is
// about to go past the end of the actual buffer, we execute code
// identical to the code executed when the buffer event is larger
// than the test event.
//
//
// To search a text buffer is rather fuzzy.  If you have a misspelled
// word 15 characters long it could take four extra iterations of the
// routine to determine that the search will fail.  Do not be fooled
// into thinking that code can be added to test for this condition
// and speed up the search.  When one is about to fail, one is
// heading for a stop.  If you speed up to stop, (an oxymoronic
// condition) you slow down the rest.
//
